/*  
 *
 * Copyright (C) 2000 Panagiotis Issaris <takis@lumumba.luc.ac.be> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * $Author: takis $
 * $Date: 2000/09/20 15:49:13 $
 * $Revision: 1.2 $
 *
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <math.h>
#include <libmpeg3/libmpeg3.h>

#define MPEG_FN "test.mpg"
#define SRC_IMG1_FN "s1.bmp"
#define SRC_IMG2_FN "s2.bmp"
#define BACKGROUND_IMG_FN "aw.jpg"
#define ALPHA_BLEND 128
#define MOVIE_FN "test.mpg"

typedef struct 
{
	char *filename;
	mpeg3_t *file;
	int nr_vstreams;
	int width, height;
	int frames;
	float framerate;
	int frame_number;
	unsigned char *framebuffer;
	unsigned char **rows;
} MPEG_Movie;


GdkPixbuf* MPEG_Movie_get_frame (MPEG_Movie *);

MPEG_Movie* MPEG_Movie_new();

void MPEG_Movie_free(MPEG_Movie *m);

MPEG_Movie* MPEG_Movie_load (char *movie_filename);

