;
;  Copyright (C) 2000 Panagiotis Issaris <takis@lumumba.luc.ac.be> 
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;
; $Author: takis $
; $Date: 2000/09/20 15:49:13 $
; $Revision: 1.1 $
;
;

global blends
global blendd

section .data
zero db 0,0,0,0,0,0,0,0
alpha db 128,0,0,0,0,0,0,0
mask_red db 255,0,0,0,0,0,0,0
mask_green db 0,0,255,0,0,0,0,0
mask_blue db 0,0,0,0,255,0,0,0
mask_alpha db 0,0,0,255,0,0,0,0
mask db 255,255,255,255,255,255,0,0

section .bss

section .text

; blends(uchar *s1, uchar *s2, uchar* d, int w, int h)
; s1	ebp+8
; s2	ebp+12
; d 	ebp+16
; w     ebp+20
; h     ebp+24
blends:
  push ebp
  mov ebp, esp
		
  ; Save all registers to the stack
  push ebx
  push ecx
  push edx
  push edi
  push esi

  emms

  mov esi, [ebp+8]
  mov edi, [ebp+12]
  mov eax, [ebp+16]
  mov edx, [ebp+20]
  imul edx, [ebp+24]
  imul edx, 3

  mov ecx, 0
.for_loop:
	movd mm2, [esi+ecx]
	movd mm3, [edi+ecx]

 	movq mm1, [zero]
    punpcklbw mm2,mm1
	punpcklbw mm3,mm1
		
	psubw mm2,mm3

	movq mm4, [alpha]
    punpcklwd mm4,mm4
	punpckldq mm4,mm4
	pmullw mm2, mm4

	psraw mm2, 8
	paddw mm2,mm3

	movq mm3, mm2
	pand mm3, [mask_red]

	movq mm4, mm2
	pand mm4, [mask_green]
	psrlq mm4, 8
	por mm3,mm4

	pand mm2, [mask_blue]
	psrlq mm2, 16
	por mm3,mm2

	movd [eax+ecx], mm3

	add ecx,3

	cmp ecx, edx
	jne near .for_loop

	emms

  ; Restore all registers from the stack
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
	
  mov esp,ebp
  pop ebp
ret
; END blends


; blendd(uchar *s1, uchar *s2, uchar* d, int w, int h)
; s1	ebp+8
; s2	ebp+12
; d 	ebp+16
; w     ebp+20
; h     ebp+24
blendd:
  push ebp
  mov ebp, esp
		
  ; Save all registers to the stack
  push ebx
  push ecx
  push edx
  push edi
  push esi


	emms
  mov esi, [ebp+8]
  mov edi, [ebp+12]
  mov eax, [ebp+16]
  mov edx, [ebp+20]
  imul edx, [ebp+24]
  imul edx, 3

	mov ecx, 0
.for_loop:

	movd mm2, [esi+ecx]
		
	movd mm3, [edi+ecx]
	; Extract alpha value 
	movq mm4, mm2
	pand mm4, [mask_alpha]
	psrlq mm4, 8*3

 	movq mm1, [zero]
    punpcklbw mm2,mm1
	punpcklbw mm3,mm1
		
	psubw mm2,mm3

	punpcklwd mm4,mm4
	punpckldq mm4,mm4
	pmullw mm2, mm4

	psraw mm2, 8
	paddw mm2,mm3

	movq mm3, mm2
	pand mm3, [mask_red]

	movq mm4, mm2
	pand mm4, [mask_green]
	psrlq mm4, 8
	por mm3,mm4

	pand mm2, [mask_blue]
	psrlq mm2, 16
	por mm3,mm2

	movd [eax+ecx], mm3

	add ecx,3

	cmp ecx, edx
	jne near .for_loop

	emms
  
  ; Restore all registers from the stack
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
	
  mov esp,ebp
  pop ebp
ret
; END blendd

